<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>User Detail</title>
</head>

<body>
    <div class="container">
        <h1>Chi tiết user</h1>
        <div class="form-group row">
            <label for="inp-firstname" class="col-sm-2 col-form-label">First Name</label>
            <div class="col-sm-10">
                <input type="text" class="form-control" id="inp-firstname">
            </div>
        </div>
        <div class="form-group row">
            <label for="inp-lastname" class="col-sm-2 col-form-label">Last Name</label>
            <div class="col-sm-10">
                <input type="text" class="form-control" id="inp-lastname">
            </div>
        </div>
        <div class="form-group row">
            <label for="inp-subject" class="col-sm-2 col-form-label">Subject</label>
            <div class="col-sm-10">
                <input type="text" class="form-control" id="inp-subject">
            </div>
        </div>
        <div class="form-group row">
            <label for="select-country" class="col-sm-2 col-form-label">Country</label>
            <div class="col-sm-10">
                <select name="" id="select-country" class="form-control">
                    <option value="VN">Việt Nam</option>
                    <option value="USA">USA</option>
                    <option value="AUS">Australia</option>
                    <option value="CAN">Canada</option>
                </select>
            </div>
        </div>
        <div class="form-group row">
            <label for="select-customer-type" class="col-sm-2 col-form-label">Customer Type</label>
            <div class="col-sm-10">
                <select name="" id="select-customer-type" class="form-control">
                    <option value="Standard">Standard</option>
                    <option value="Gold">Gold</option>
                    <option value="Premium">Premium</option>

                </select>
            </div>
        </div>
        <div class="form-group row">
            <label for="select-register-status" class="col-sm-2 col-form-label">Register status</label>
            <div class="col-sm-10">
                <select name="" id="select-register-status" class="form-control">
                    <option value="New">New</option>
                    <option value="Accepted">Acceptedc</option>
                    <option value="Denied">Denied</option>
                </select>
            </div>
        </div>
        <div class="btn-group">
            <button class="btn btn-success mr-1 btn-update">Update User</button>
            <button class="btn btn-success btn-exit">Hủy bỏ</button>
        </div>

    </div>
</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_STATUS_CREATE_OK = 201;
    const gREQUEST_STATUS_DELETE_OK = 204;
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
    var gUrl = new URL(window.location.href);
    var gId = gUrl.searchParams.get("id");
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        onPageLoading();
        $(".btn-update").on("click", function () {
            var vUserDetailObj = {
                firstname: "",
                lastname: "",
                subject: "",
                country: "",
                customerType: "",
                registerStatus: ""
            }
            //b1: truy xuất dữ liệu:
            truyXuatDuLieu(vUserDetailObj)
            //b2: validate dữ liệu
            var vDuLieuHopLe = validateUserDetail(vUserDetailObj);
            if (vDuLieuHopLe) {
                //b3:  call api
                $.ajax({
                    url: gBASE_URL + gId,
                    type: "PUT",
                    contentType: "application/json",
                    data: JSON.stringify(vUserDetailObj),
                    success: function (responseObj) {
                        console.log(responseObj);
                        alert("Cập nhật thành công!")
                        window.location.href = "listUser.html"
                    },
                    error: function (ajaxContext) {
                        alert(ajaxContext.responseText)
                        window.location.href = "listUser.html"

                    }
                });
            }
            //b4: update dữ liệu




        });
        $(".btn-exit").on("click", function () {
            window.location.href = "listUser.html"
        });


    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        //thu thập dữ liệu từ query string:
        var vUrlString = window.location.href;
        var vUrl = new URL(vUrlString)
        //get parameters:
        var vId = vUrl.searchParams.get("id");
        console.log(vId)
        callApiToGetDataById(vId)
    }

    function callApiToGetDataById(paramUserId) {
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/" + paramUserId,
            type: "GET",
            dataType: "json",
            success: function (DataUserObj) {
                console.log(DataUserObj)
                showDataUse(DataUserObj)
            },
            error: function (ajaxContext) {
                alert(ajaxContext.responseText)
            }
        })
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function showDataUse(paramUserData) {
        "use strict";
        $("#inp-firstname").val(paramUserData.firstname);
        $("#inp-lastname").val(paramUserData.lastname);
        $("#inp-subject").val(paramUserData.subject);
        $("#select-country").val(paramUserData.country);
        $("#select-customer-type").val(paramUserData.customerType);
        $("#select-register-status").val(paramUserData.registerStatus);

    }
    //b1: truy xuất dữ liệu:
    function truyXuatDuLieu(paramUserDetailObj) {
        "use strict";
        paramUserDetailObj.firstname = $("#inp-firstname").val().trim();
        paramUserDetailObj.lastname = $("#inp-lastname").val().trim();
        paramUserDetailObj.subject = $("#inp-subject").val().trim();
        paramUserDetailObj.country = $("#select-country").val();
        paramUserDetailObj.customerType = $("#select-customer-type").val();
        paramUserDetailObj.registerStatus = $("#select-register-status").val();
    }
    //b2: validate dữ liệu
    function validateUserDetail(paramUserDetailObj) {
        if (paramUserDetailObj.firstname == "") {
            alert("Hãy nhập firstname!")
            return false
        }
        if (paramUserDetailObj.lastname == "") {
            alert("Hãy nhập lastname!")
            return false
        }
        if (paramUserDetailObj.subject == "") {
            alert("Hãy nhập subject!")
            return false
        }
        if (paramUserDetailObj.country == null) {
            alert("Hãy chọn country!")
            return false
        }
        if (paramUserDetailObj.customerType == null) {
            alert("Hãy chọn customer type!")
            return false
        }
        if (paramUserDetailObj.registerStatus == null) {
            alert("Hãy chọn register status!")
            return false
        }
        return true
    }


</script>

</html>